class Stack(object):

    def __init__(self, tibetan, index=0):
        """
        This class should only be passed a stack, not a full Tibetan word. If a
        full word is passed, only the first stack will be processed.
        Optionally, an index parameter may be defined, indicating which stack
        in the word to process.

        @param tibetan: this can be either encoded or decoded unicode.
        @param index: if a full word is passed in the tibetan parameter, the
            index parameter (starting at 0) can be used to indicate which stack
            in the word to process; if the index is greater than the number of
            stacks in the word, and IndexError exception will be raised.
        """
        # XXX these were copied from the perl code... but I'm not sure how
        # useful/necssary all these attributes are.
        self.top = None
        self.consonants = []
        self.caret = None
        self.vowels = []
        self.finals = []
        self.finals_found = {}
        self.visarga = False
        self.cons_str = None
        self.single_cons = True
        self.prefix = None
        self.suffix = None
        self.second_suffix = None
        self.dot = None

        # process the given stack
        self.original = tibetan
        self.text = util.decode(tibetan)
        self.start_index = index
        self._parse()

    def _scan_for_end(self):
        """
        Find the index for the end of the stack.
        """
        print
        for index, code_point in enumerate(self.text[self.start_index+1:]):
            print index, repr(code_point)
            if is_stack(code_point):
                continue
            else:
                return index
        return index

    def _parse(self):
        pass

