import unicodedata


tib_top = {
    u'\u0f40': 'k',     # TIBETAN LETTER KA
    u'\u0f41': 'kh',    # TIBETAN LETTER KHA
    u'\u0f42': 'g',     # TIBETAN LETTER GA
    u'\u0f43': 'g+h',   # TIBETAN LETTER GHA
    u'\u0f44': 'ng',    # TIBETAN LETTER NGA
    u'\u0f45': 'c',     # TIBETAN LETTER CA
    u'\u0f46': 'ch',    # TIBETAN LETTER CHA
    u'\u0f47': 'j',     # TIBETAN LETTER JA
    u'\u0f49': 'ny',    # TIBETAN LETTER NYA
    u'\u0f4a': 'T',     # TIBETAN LETTER TTA
    u'\u0f4b': 'Th',    # TIBETAN LETTER TTHA
    u'\u0f4c': 'D',     # TIBETAN LETTER DDA
    u'\u0f4d': 'D+h',   # TIBETAN LETTER DDHA
    u'\u0f4e': 'N',     # TIBETAN LETTER NNA
    u'\u0f4f': 't',     # TIBETAN LETTER TA
    u'\u0f50': 'th',    # TIBETAN LETTER THA
    u'\u0f51': 'd',     # TIBETAN LETTER DA
    u'\u0f52': 'd+h',   # TIBETAN LETTER DHA
    u'\u0f53': 'n',     # TIBETAN LETTER NA
    u'\u0f54': 'p',     # TIBETAN LETTER PA
    u'\u0f55': 'ph',    # TIBETAN LETTER PHA
    u'\u0f56': 'b',     # TIBETAN LETTER BA
    u'\u0f57': 'b+h',   # TIBETAN LETTER BHA
    u'\u0f58': 'm',     # TIBETAN LETTER MA
    u'\u0f59': 'ts',    # TIBETAN LETTER TSA
    u'\u0f5a': 'tsh',   # TIBETAN LETTER TSHA
    u'\u0f5b': 'dz',    # TIBETAN LETTER DZA
    u'\u0f5c': 'dz+h',  # TIBETAN LETTER DZHA
    u'\u0f5d': 'w',     # TIBETAN LETTER WA
    u'\u0f5e': 'zh',    # TIBETAN LETTER ZHA
    u'\u0f5f': 'z',     # TIBETAN LETTER ZA
    u'\u0f60': "'",     # TIBETAN LETTER -A
    u'\u0f61': 'y',     # TIBETAN LETTER YA
    u'\u0f62': 'r',     # TIBETAN LETTER RA
    u'\u0f63': 'l',     # TIBETAN LETTER LA
    u'\u0f64': 'sh',    # TIBETAN LETTER SHA
    u'\u0f65': 'Sh',    # TIBETAN LETTER SSA
    u'\u0f66': 's',     # TIBETAN LETTER SA
    u'\u0f67': 'h',     # TIBETAN LETTER HA
    u'\u0f68': 'a',     # TIBETAN LETTER A
    u'\u0f69': 'k+Sh',  # TIBETAN LETTER KSSA
    u'\u0f6a': 'R',     # TIBETAN LETTER FIXED-FORM RA
    }


tib_subjoined = {
    u'\u0f90': 'k',     # TIBETAN SUBJOINED LETTER KA
    u'\u0f91': 'kh',    # TIBETAN SUBJOINED LETTER KHA
    u'\u0f92': 'g',     # TIBETAN SUBJOINED LETTER GA
    u'\u0f93': 'g+h',   # TIBETAN SUBJOINED LETTER GHA
    u'\u0f94': 'ng',    # TIBETAN SUBJOINED LETTER NGA
    u'\u0f95': 'c',     # TIBETAN SUBJOINED LETTER CA
    u'\u0f96': 'ch',    # TIBETAN SUBJOINED LETTER CHA
    u'\u0f97': 'j',     # TIBETAN SUBJOINED LETTER JA
    u'\u0f99': 'ny',    # TIBETAN SUBJOINED LETTER NYA
    u'\u0f9a': 'T',     # TIBETAN SUBJOINED LETTER TTA
    u'\u0f9b': 'Th',    # TIBETAN SUBJOINED LETTER TTHA
    u'\u0f9c': 'D',     # TIBETAN SUBJOINED LETTER DDA
    u'\u0f9d': 'D+h',   # TIBETAN SUBJOINED LETTER DDHA
    u'\u0f9e': 'N',     # TIBETAN SUBJOINED LETTER NNA
    u'\u0f9f': 't',     # TIBETAN SUBJOINED LETTER TA
    u'\u0fa0': 'th',    # TIBETAN SUBJOINED LETTER THA
    u'\u0fa1': 'd',     # TIBETAN SUBJOINED LETTER DA
    u'\u0fa2': 'd+h',   # TIBETAN SUBJOINED LETTER DHA
    u'\u0fa3': 'n',     # TIBETAN SUBJOINED LETTER NA
    u'\u0fa4': 'p',     # TIBETAN SUBJOINED LETTER PA
    u'\u0fa5': 'ph',    # TIBETAN SUBJOINED LETTER PHA
    u'\u0fa6': 'b',     # TIBETAN SUBJOINED LETTER BA
    u'\u0fa7': 'b+h',   # TIBETAN SUBJOINED LETTER BHA
    u'\u0fa8': 'm',     # TIBETAN SUBJOINED LETTER MA
    u'\u0fa9': 'ts',    # TIBETAN SUBJOINED LETTER TSA
    u'\u0faa': 'tsh',   # TIBETAN SUBJOINED LETTER TSHA
    u'\u0fab': 'dz',    # TIBETAN SUBJOINED LETTER DZA
    u'\u0fac': 'dz+h',  # TIBETAN SUBJOINED LETTER DZHA
    u'\u0fad': 'w',     # TIBETAN SUBJOINED LETTER WA
    u'\u0fae': 'zh',    # TIBETAN SUBJOINED LETTER ZHA
    u'\u0faf': 'z',     # TIBETAN SUBJOINED LETTER ZA
    u'\u0fb0': "'",     # TIBETAN SUBJOINED LETTER -A
    u'\u0fb1': 'y',     # TIBETAN SUBJOINED LETTER YA
    u'\u0fb2': 'r',     # TIBETAN SUBJOINED LETTER RA
    u'\u0fb3': 'l',     # TIBETAN SUBJOINED LETTER LA
    u'\u0fb4': 'sh',    # TIBETAN SUBJOINED LETTER SHA
    u'\u0fb5': 'Sh',    # TIBETAN SUBJOINED LETTER SSA
    u'\u0fb6': 's',     # TIBETAN SUBJOINED LETTER SA
    u'\u0fb7': 'h',     # TIBETAN SUBJOINED LETTER HA
    u'\u0fb8': 'a',     # TIBETAN SUBJOINED LETTER A
    u'\u0fb9': 'k+Sh',  # TIBETAN SUBJOINED LETTER KSSA
    u'\u0fba': 'W',     # TIBETAN SUBJOINED LETTER FIXED-FORM WA
    u'\u0fbb': 'Y',     # TIBETAN SUBJOINED LETTER FIXED-FORM YA
    u'\u0fbc': 'R',     # TIBETAN SUBJOINED LETTER FIXED-FORM RA
    }


tib_vowel = {
    # a-chen is not here because that's a top character, not a vowel sign.
    # pre-composed "I" and "U" are dealt here; other pre-composed Skt vowels
    # are more easily handled by a global replace in to_wylie(), b/c they turn
    # into subjoined "r"/"l".

    u'\u0f71': 'A',     # TIBETAN VOWEL SIGN AA
    u'\u0f72': 'i',     # TIBETAN VOWEL SIGN I
    u'\u0f73': 'I',     # TIBETAN VOWEL SIGN II
    u'\u0f74': 'u',     # TIBETAN VOWEL SIGN U
    u'\u0f75': 'U',     # TIBETAN VOWEL SIGN UU
    u'\u0f7a': 'e',     # TIBETAN VOWEL SIGN E
    u'\u0f7b': 'ai',    # TIBETAN VOWEL SIGN EE
    u'\u0f7c': 'o',     # TIBETAN VOWEL SIGN O
    u'\u0f7d': 'au',    # TIBETAN VOWEL SIGN OO
    u'\u0f80': '-i',    # TIBETAN VOWEL SIGN REVERSED I
    u'\u0f81': '-I',    # TIBETAN VOWEL SIGN REVERSED II
    }


tib_final = {
    u'\u0f35': ['~X', 'X'],    # TIBETAN MARK NGAS BZUNG NYI ZLA
    u'\u0f37': ['X', 'X'],     # TIBETAN MARK NGAS BZUNG SGOR RTAGS
    u'\u0f39': ['^', '^'],     # TIBETAN MARK TSA -PHRU
    u'\u0f7e': ['M', 'M'],     # TIBETAN SIGN RJES SU NGA RO
    u'\u0f7f': ['H', 'H'],     # TIBETAN SIGN RNAM BCAD
    u'\u0f82': ['~M`', 'M'],   # TIBETAN SIGN NYI ZLA NAA DA
    u'\u0f83': ['~M', 'M'],    # TIBETAN SIGN SNA LDAN
    u'\u0f84': ['?', '?'],     # TIBETAN MARK HALANTA
    }


tib_other = {
    u'\u0020': '_',     # SPACE
    u'\u0f04': '@',     # TIBETAN MARK INITIAL YIG MGO MDUN MA
    u'\u0f05': '#',     # TIBETAN MARK CLOSING YIG MGO SGAB MA
    u'\u0f06': '$',     # TIBETAN MARK CARET YIG MGO PHUR SHAD MA
    u'\u0f07': '%',     # TIBETAN MARK YIG MGO TSHEG SHAD MA
    u'\u0f08': '!',     # TIBETAN MARK SBRUL SHAD
    u'\u0f0b': ' ',     # TIBETAN MARK INTERSYLLABIC TSHEG
    u'\u0f0c': '*',     # TIBETAN MARK DELIMITER TSHEG BSTAR
    u'\u0f0d': '/',     # TIBETAN MARK SHAD
    u'\u0f0e': '//',    # TIBETAN MARK NYIS SHAD
    u'\u0f0f': ';',     # TIBETAN MARK TSHEG SHAD
    u'\u0f11': '|',     # TIBETAN MARK RIN CHEN SPUNGS SHAD
    u'\u0f14': ':',     # TIBETAN MARK GTER TSHEG
    u'\u0f20': '0',     # TIBETAN DIGIT ZERO
    u'\u0f21': '1',     # TIBETAN DIGIT ONE
    u'\u0f22': '2',     # TIBETAN DIGIT TWO
    u'\u0f23': '3',     # TIBETAN DIGIT THREE
    u'\u0f24': '4',     # TIBETAN DIGIT FOUR
    u'\u0f25': '5',     # TIBETAN DIGIT FIVE
    u'\u0f26': '6',     # TIBETAN DIGIT SIX
    u'\u0f27': '7',     # TIBETAN DIGIT SEVEN
    u'\u0f28': '8',     # TIBETAN DIGIT EIGHT
    u'\u0f29': '9',     # TIBETAN DIGIT NINE
    u'\u0f34': '=',     # TIBETAN MARK BSDUS RTAGS
    u'\u0f3a': '<',     # TIBETAN MARK GUG RTAGS GYON
    u'\u0f3b': '>',     # TIBETAN MARK GUG RTAGS GYAS
    u'\u0f3c': '(',     # TIBETAN MARK ANG KHANG GYON
    u'\u0f3d': ')',     # TIBETAN MARK ANG KHANG GYAS
    }


tib_all = [tib_top, tib_subjoined, tib_vowel, tib_final, tib_other]

unicodeTop = tib_top.keys()
unicodeSubjoined = tib_subjoined.keys()
unicodeVowels = tib_vowel.keys()
unicodeFinal = tib_final.keys()

unicodeLetters = unicodeTop + unicodeSubjoined + unicodeVowels + unicodeFinal

unicodeOther = tib_other.keys()

# a finer-grained break-down, based on standard Tibetan syllabic analysis
tibPrefixes = {
    u"\u0f42": "g",
    u"\u0f51": "d",
    u"\u0f56": "b",
    u"\u0f58": "m",
    u"\u0f60": "'",
    }

tibSuperfixes = {
    u"\u0f62": "r",
    u"\u0f63": "l",
    u"\u0f66": "s",
    }

tibSubfixes = {
    u"\u0f61": "y",
    u"\u0f62": "r",
    u"\u0f63": "l",
    u"\u0f5d": "w",
    u"\u0f60": "'",
    }

tibSuffixes = {
    u"\u0f42": "g",
    u"\u0f44": "ng",
    u"\u0f51": "d",
    u"\u0f53": "n",
    u"\u0f56": "b",
    u"\u0f58": "m",
    u"\u0f60": "'",
    u"\u0f62": "r",
    u"\u0f63": "l",
    u"\u0f66": "s",
    }

tibPostSuffixes = {
    u"\u0f66": "s",
    }

unicodePrefixes = tibPrefixes.keys()
unicodeSuperfixes = tibSuperfixes.keys()
unicodeSubfixes = tibSubfixes.keys()
unicodeSuffixes = tibSuffixes.keys()
unicodePostSuffixes = tibPostSuffixes.keys()


def printTibetanUnicodeTable():
    #for key, value in sorted(tib_top.items()):
    #for key, value in sorted(tib_subjoined.items()):
    #for key, value in sorted(tib_vowel.items()):
    #for key, value in sorted(tib_final.items()):
    for key, value in sorted(tib_other.items()):
        print "%s: '%s', \t# %s" % (
            repr(key), value, unicodedata.name(key))


if __name__ == '__main__':
    printTibetanUnicodeTable()
