from tibetan.translit.unicode import mapper
from tibetan import util


def is_word(code_point):
    if (mapper.tib_top.get(code_point) or
        mapper.tib_subjoined.get(code_point) or
        mapper.tib_vowel.get(code_point) or
        mapper.tib_final.get(code_point)):
        return True
    return False


def is_stack(code_point):
    pass


def parse_stack(unicode_text):
    stacks = []
    print
    print unicode_text
    text = util.decode(unicode_text)
    print "full stack:", repr(text)
    stack = ""
    legal_stack_letters = (
        mapper.tib_top.keys() + mapper.tib_subjoined.keys() +
        mapper.tib_vowel.keys() + mapper.tib_final.keys())
    for letter in text:
        if letter not in legal_stack_letters:
            continue
        if not stack and letter in mapper.tib_top.keys():
            stack += letter
        elif letter in mapper.tib_subjoined.keys():
            stack += letter
        elif letter in mapper.tib_vowel.keys():
            stack += letter
            stacks.append(stack)
            stack = ""
        elif letter in mapper.tib_final.keys():
            stack += letter
            stack.append(stack)
            stack = ""
        elif stack and letter in mapper.tib_top.keys():
            stacks.append(stack)
            stack = letter
        else:
            stacks.append(stack)
            stack = ""
            print "hrmm...", letter.encode("utf-8")
    if stack:
        stacks.append(stack)
        stack = ""
    # first letter is the start of the stack
    # when we hit a vowel, that's the end of the stack
    print stacks
    for stack in stacks:
        print "stack:", stack.encode("utf-8")


class UnicodeParser(object):

    def __init__(
        self, string="", check=True, check_strict=True, print_warnings=True,
        fix_spacing=True):
        self.string = string
        self._warnings = []

    def get_warnings(self):
        return self._warnings

    def to_wylie(self, string=""):
        if not string:
            string = self.string
        self._warnings = []
        string = util.fixDeprecated(string)

        # split into code points
        for token in string:
            print mapper.tib_top.get(token)

    def _to_wylie_one_stack(self, tokens, index):
        """
        split the stack into:
            - top symbol
            - stacked signs (first is the top symbol again, then subscribed
              main characters...)
            - caret (did we find a stray tsa-phru or not?)
            - vowel signs (including small subscribed a-chung, "-i" Skt signs,
              etc)
            - final stuff (including anusvara, visarga, halanta...)
            - and some more variables to keep track of what has been found
        """
        # assume: tib_top{$t} exists
        tibetan_letter = tokens[index]
        print "\nto_wylie_one_stack, tibetan_letter: %s" % (
            tibetan_letter.encode("utf-8"),)

        # grab everything else below the top sign and classify in various
        # categories

            # check for bad ordering...

            # check for bad ordering...

            # check for invalid combinations...

        # a-chen with vowel signs: remove the "a" and keep the vowel signs

        # handle long vowels: A+i becomes I, etc.

        # special cases: "ph^" becomes "f", "b^" becomes "v"

        # if this is a single consonant, keep track of it (useful for
        # prefix/suffix analysis        

        # return the analyzed stack
        return (None, None, None)

    def _put_stack_together(self, stack):
        # XXX rename to _assemble_stack
        pass

    def _to_wylie_one_tsek_bar(self, tokens, index):

        # make a list of stacks, until we get to punctuation or to a visarga
        stack_tokens, stack, warnings = self._to_wylie_one_stack(tokens, index)
        # update warngins data structure
        #index +=

        # figure out if some of these stacks can be prefixes or suffixes (in
        # which case they don't need their "a" vowels)

        # if there are two stacks and both can be prefix-suffix, then 1st is
        # root

        # if there are three stacks and they can be prefix, suffix and suff2,
        # then check w/ a table

        # if the prefix together with the main stack could be mistaken for a
        # single stack, add a "."

        # assemble stacks

    def _dump(self, string):
        pass
