consonant = {
    "k": "\u0f40",
    "kh": "\u0f41",
    "g": "\u0f42",
    "gh": "\u0f42\u0fb7",
    "g+h": "\u0f42\u0fb7",
    "ng": "\u0f44",
    "c": "\u0f45",
    "ch": "\u0f46",
    "j": "\u0f47",
    "ny": "\u0f49",
    "T": "\u0f4a",
    "-t": "\u0f4a",
    "Th": "\u0f4b",
    "-th": "\u0f4b",
    "D": "\u0f4c",
    "-d": "\u0f4c",
    "Dh": "\u0f4c\u0fb7",
    "D+h": "\u0f4c\u0fb7",
    "-dh": "\u0f4c\u0fb7",
    "-d+h": "\u0f4c\u0fb7",
    "N": "\u0f4e",
    "-n": "\u0f4e",
    "t": "\u0f4f",
    "th": "\u0f50",
    "d": "\u0f51",
    "dh": "\u0f51\u0fb7",
    "d+h": "\u0f51\u0fb7",
    "n": "\u0f53",
    "p": "\u0f54",
    "ph": "\u0f55",
    "b": "\u0f56",
    "bh": "\u0f56\u0fb7",
    "b+h": "\u0f56\u0fb7",
    "m": "\u0f58",
    "ts": "\u0f59",
    "tsh": "\u0f5a",
    "dz": "\u0f5b",
    "dzh": "\u0f5b\u0fb7",
    "dz+h": "\u0f5b\u0fb7",
    "w": "\u0f5d",
    "zh": "\u0f5e",
    "z": "\u0f5f",
    "'": "\u0f60",
    # typographic quotes
    "\u2018": "\u0f60",
    "\u2019": "\u0f60",
    "y": "\u0f61",
    "r": "\u0f62",
    "l": "\u0f63",
    "sh": "\u0f64",
    "Sh": "\u0f65",
    "-sh": "\u0f65",
    "s": "\u0f66",
    "h": "\u0f67",
    "W": "\u0f5d",
    "Y": "\u0f61",
    "R": "\u0f6a",
    "f": "\u0f55\u0f39",
    "v": "\u0f56\u0f39",
    }


subjoined = {
    "k": "\u0f90",
    "kh": "\u0f91",
    "g": "\u0f92",
    "gh": "\u0f92\u0fb7",
    "g+h": "\u0f92\u0fb7",
    "ng": "\u0f94",
    "c": "\u0f95",
    "ch": "\u0f96",
    "j": "\u0f97",
    "ny": "\u0f99",
    "T": "\u0f9a",
    "-t": "\u0f9a",
    "Th": "\u0f9b",
    "-th": "\u0f9b",
    "D": "\u0f9c",
    "-d": "\u0f9c",
    "Dh": "\u0f9c\u0fb7",
    "D+h": "\u0f9c\u0fb7",
    "-dh": "\u0f9c\u0fb7",
    "-d+h": "\u0f9c\u0fb7",
    "N": "\u0f9e",
    "-n": "\u0f9e",
    "t": "\u0f9f",
    "th": "\u0fa0",
    "d": "\u0fa1",
    "dh": "\u0fa1\u0fb7",
    "d+h": "\u0fa1\u0fb7",
    "n": "\u0fa3",
    "p": "\u0fa4",
    "ph": "\u0fa5",
    "b": "\u0fa6",
    "bh": "\u0fa6\u0fb7",
    "b+h": "\u0fa6\u0fb7",
    "m": "\u0fa8",
    "ts": "\u0fa9",
    "tsh": "\u0faa",
    "dz": "\u0fab",
    "dzh": "\u0fab\u0fb7",
    "dz+h": "\u0fab\u0fb7",
    "w": "\u0fad",
    "zh": "\u0fae",
    "z": "\u0faf",
    "'": "\u0fb0",
    # typographic quotes
    "\u2018": "\u0fb0",
    "\u2019": "\u0fb0",
    "y": "\u0fb1",
    "r": "\u0fb2",
    "l": "\u0fb3",
    "sh": "\u0fb4",
    "Sh": "\u0fb5",
    "-sh": "\u0fb5",
    "s": "\u0fb6",
    "h": "\u0fb7",
    "a": "\u0fb8",
    "W": "\u0fba",
    "Y": "\u0fbb",
    "R": "\u0fbc",
    }


vowel = {
    # a-chen
    "a": "\u0f68",
    "A": "\u0f71",
    "i": "\u0f72",
    "I": "\u0f71\u0f72",
    "u": "\u0f74",
    "U": "\u0f71\u0f74",
    "e": "\u0f7a",
    "ai": "\u0f7b",
    "o": "\u0f7c",
    "au": "\u0f7d",
    "-i": "\u0f80",
    "-I": "\u0f71\u0f80",
    # these are handled as "lata" or "rata" plus inverted vowel sign
    #"r-i": "\u0fb2\u0f80",
    #"r-I": "\u0fb2\u0f71\u0f80",
    #"l-i": "\u0fb3\u0f80",
    #"l-I": "\u0fb3\u0f71\u0f80",
    }


other = {
    "0": "\u0f20",
    "1": "\u0f21",
    "2": "\u0f22",
    "3": "\u0f23",
    "4": "\u0f24",
    "5": "\u0f25",
    "6": "\u0f26",
    "7": "\u0f27",
    "8": "\u0f28",
    "9": "\u0f29",
    # "-": "\u0f0b",
    " ": "\u0f0b",
    "*": "\u0f0c",
    "/": "\u0f0d",
    "//": "\u0f0e",
    ";": "\u0f0f",
    "|": "\u0f11",
    "!": "\u0f08",
    ":": "\u0f14",
    "_": " ",
    "=": "\u0f34",
    "<": "\u0f3a",
    ">": "\u0f3b",
    "(": "\u0f3c",
    ")": "\u0f3d",
    "@": "\u0f04",
    "#": "\u0f05",
    "$": "\u0f06",
    "%": "\u0f07",
    }


# stuff that can come after the vowel; cannot have more than 1 of the same
# class in the same stack
# symbol: [unicode, class]
final = {
    # anusvara / bindu / circle above / nga ro
    "M": ["\u0f7e", "M"],   
    # visarga / rnam bcad
    "H": ["\u0f7f", "H"],   
    # crescent, bindu & nada
    "~M`": ["\u0f82", "M"],   
    # crescent & bindu
    "~M": ["\u0f83", "M"],   
    # halanta / srog med
    "?": ["\u0f84", "?"],   
    # small circle under
    "X": ["\u0f37", "X"],   
    # small circle w/ crescent under
    "~X": ["\u0f35", "X"],   
    # tsa-phru
    "^": ["\u0f39", "^"],   
    }


tib_vowel_long = {
    "i": "I",
    "u": "U",
    "-i": "-I",
    }

tib_caret = {
    "ph": "f",
    "b": "v",
    }


special_characters = [".", "+", "-", "~", "^", "?", "`", "]"]
special = dict(map(lambda x: (x, 1), special_characters))

# superscript setup
super_r_characters = [
    "k", "g", "ng", "j", "ny", "t", "d", "n", "b", "m", "ts", "dz", "k+y",
    "g+y", "m+y", "b+w", "ts+w", "g+w"]
super_r = dict(map(lambda x: (x, 1), super_r_characters))
super_l_characters = [
    "k", "g", "ng", "c", "j", "t", "d", "p", "b", "h"]
super_l = dict(map(lambda x: (x, 1), super_l_characters))
super_s_characters = [
    "k", "g", "ng", "ny", "t", "d", "n", "p", "b", "m", "ts", "k+y", "g+y",
    "p+y", "b+y", "m+y", "k+r", "g+r", "p+r", "b+r", "m+r", "n+r"]
super_s = dict(map(lambda x: (x, 1), super_s_characters))
superscripts = {
    "r": super_r,
    "l": super_l,
    "s": super_s}


# subscript setup
sub_y_characters = [
    "k", "kh", "g", "p", "ph", "b", "m", "r+k", "r+g", "r+m", "s+k", "s+g",
    "s+p", "s+b", "s+m"]
sub_y = dict(map(lambda x: (x, 1), sub_y_characters))
sub_r_characters = [
    "k", "kh", "g", "t", "th", "d", "n", "p", "ph", "b", "m", "sh", "s", "h",
    "dz", "s+k", "s+g", "s+p", "s+b", "s+m", "s+n"]
sub_r = dict(map(lambda x: (x, 1), sub_r_characters))
sub_l_characters = ["k", "g", "b", "r", "s", "z"]
sub_l = dict(map(lambda x: (x, 1), sub_l_characters))
sub_w_characters = [
    "k", "kh", "g", "c", "ny", "t", "d", "ts", "tsh", "zh", "z", "r", "l",
    "sh", "s", "h", "g+r", "d+r", "ph+y", "r+g", "r+ts"]
sub_w = dict(map(lambda x: (x, 1), sub_w_characters))
subscripts = {
    "y": sub_y,
    "r": sub_r,
    "l": sub_l,
    "w": sub_w}


# prefixe setup
pre_g_characters = ["c", "ny", "t", "d", "n", "ts", "zh", "z", "y", "sh", "s"]
pre_g = dict(map(lambda x: (x, 1), pre_g_characters))
pre_d_characters = [
    "k", "g", "ng", "p", "b", "m", "k+y", "g+y", "p+y", "b+y", "m+y", "k+r",
    "g+r", "p+r", "b+r"]
pre_d = dict(map(lambda x: (x, 1), pre_d_characters))
pre_b_characters = [
    "k", "g", "c", "t", "d", "ts", "zh", "z", "sh", "s", "r", "l", "k+y",
    "g+y", "k+r", "g+r", "r+l", "s+l", "r+k", "r+g", "r+ng", "r+j", "r+ny",
    "r+t", "r+d", "r+n", "r+ts", "r+dz", "s+k", "s+g", "s+ng", "s+ny", "s+t",
    "s+d", "s+n", "s+ts", "r+k+y", "r+g+y", "s+k+y", "s+g+y", "s+k+r", "s+g+r",
    "l+d", "l+t", "k+l", "s+r", "z+l", "s+w"]
pre_b = dict(map(lambda x: (x, 1), pre_b_characters))
pre_m_characters = [
    "kh", "g", "ng", "ch", "j", "ny", "th", "d", "n", "tsh", "dz", "kh+y",
    "g+y", "kh+r", "g+r"]
pre_m = dict(map(lambda x: (x, 1), pre_m_characters))
pre_achung_characters = [
    "kh", "g", "ch", "j", "th", "d", "ph", "b", "tsh", "dz", "kh+y", "g+y",
    "ph+y", "b+y", "kh+r", "g+r", "d+r", "ph+r", "b+r"]
pre_achung = dict(map(lambda x: (x, 1), pre_achung_characters))
pre_quote_characters = [
    "kh", "g", "ch", "j", "th", "d", "ph", "b", "tsh", "dz", "kh+y", "g+y",
    "ph+y", "b+y", "kh+r", "g+r", "d+r", "ph+r", "b+r"]
pre_quote = dict(map(lambda x: (x, 1), pre_quote_characters))
prefixes = {
    "g": pre_g,
    "d": pre_d,
    "b": pre_b,
    "m": pre_m,
    "'": pre_achung,
    "\u2018": pre_quote,
    "\u2019": pre_quote}


# suffix setup
suffix_characters = [
    "'", "\u2018", "\u2019", "g", "ng", "d", "n", "b", "m", "r", "l", "s", "N",
    "T", "-n", "-t"]
suffixes1 = dict(map(lambda x: (x, 1), suffix_characters))
suffixes2 = {
    "s": dict(map(lambda x: (x, 1), ["g", "ng", "b", "m"])),
    "d": dict(map(lambda x: (x, 1), ["n", "r", "l"]))}


# ambiguous mappings
ambiguous = {
    "dgs": (1, "dgas"),
    "'gs": (1, "'gas"),
    "dbs": (1, "dbas"),
    "dms": (1, "dmas"),
    "bgs": (0, "bags"),
    "mngs": (0, "mangs")}

# stacked consonants
tib_stack_characters = [
    "b+l", "b+r", "b+y", "c+w", "d+r", "d+r+w", "d+w", "dz+r", "g+l", "g+r",
    "g+r+w", "g+w", "g+y", "h+r", "h+w", "k+l", "k+r", "k+w", "k+y", "kh+r",
    "kh+w", "kh+y", "l+b", "l+c", "l+d", "l+g", "l+h", "l+j", "l+k", "l+ng",
    "l+p", "l+t", "l+w", "m+r", "m+y", "n+r", "ny+w", "p+r", "p+y", "ph+r",
    "ph+y", "ph+y+w", "r+b", "r+d", "r+dz", "r+g", "r+g+w", "r+g+y", "r+j",
    "r+k", "r+k+y", "r+l", "r+m", "r+m+y", "r+n", "r+ng", "r+ny", "r+t",
    "r+ts", "r+ts+w", "r+w", "s+b", "s+b+r", "s+b+y", "s+d", "s+g", "s+g+r",
    "s+g+y", "s+k", "s+k+r", "s+k+y", "s+l", "s+m", "s+m+r", "s+m+y", "s+n",
    "s+n+r", "s+ng", "s+ny", "s+p", "s+p+r", "s+p+y", "s+r", "s+t", "s+ts",
    "s+w", "sh+r", "sh+w", "t+r", "t+w", "th+r", "ts+w", "tsh+w", "z+l", "z+w",
    "zh+w"]
tib_stacks = dict(map(lambda x: (x, 1), tib_stack_characters))
