from unittest import TestCase

from tibetan.translit.wylie import mapper
#from tibetan.translit.wylie import parser


class WylieMapperDataTestCase(TestCase):

    def test_special(self):
        self.assertEqual(
            sorted(mapper.special.keys()),
            sorted(mapper.special_characters))
        self.assertEqual(
            mapper.special.values(),
            len(mapper.special_characters) * [1])

    def test_super_r(self):
        self.assertEqual(
            sorted(mapper.super_r.keys()),
            sorted(mapper.super_r_characters))

    def test_super_l(self):
        self.assertEqual(
            sorted(mapper.super_l.keys()),
            sorted(mapper.super_l_characters))

    def test_super_s(self):
        self.assertEqual(
            sorted(mapper.super_s.keys()),
            sorted(mapper.super_s_characters))

    def test_sub_y(self):
        self.assertEqual(
            sorted(mapper.sub_y.keys()),
            sorted(mapper.sub_y_characters))

    def test_sub_r(self):
        self.assertEqual(
            sorted(mapper.sub_r.keys()),
            sorted(mapper.sub_r_characters))

    def test_sub_l(self):
        self.assertEqual(
            sorted(mapper.sub_l.keys()),
            sorted(mapper.sub_l_characters))

    def test_sub_w(self):
        self.assertEqual(
            sorted(mapper.sub_w.keys()),
            sorted(mapper.sub_w_characters))

    def test_pre_g(self):
        self.assertEqual(
            sorted(mapper.pre_g.keys()),
            sorted(mapper.pre_g_characters))

    def test_pre_d(self):
        self.assertEqual(
            sorted(mapper.pre_d.keys()),
            sorted(mapper.pre_d_characters))

    def test_pre_b(self):
        self.assertEqual(
            sorted(mapper.pre_b.keys()),
            sorted(mapper.pre_b_characters))

    def test_pre_m(self):
        self.assertEqual(
            sorted(mapper.pre_m.keys()),
            sorted(mapper.pre_m_characters))

    def test_pre_achung(self):
        self.assertEqual(
            sorted(mapper.pre_achung.keys()),
            sorted(mapper.pre_achung_characters))

    def test_quote(self):
        self.assertEqual(
            sorted(mapper.pre_quote.keys()),
            sorted(mapper.pre_quote_characters))

    def test_suffixes1(self):
        self.assertEqual(
            sorted(mapper.suffixes1.keys()),
            sorted(mapper.suffix_characters))

    def test_suffixes2(self):
        self.assertEqual(
            sorted(mapper.suffixes2.get("s").keys()),
            sorted(["g", "ng", "b", "m"]))
        self.assertEqual(
            sorted(mapper.suffixes2.get("d").keys()),
            sorted(["n", "r", "l"]))

    def test_tib_stacks(self):
        self.assertEqual(
            sorted(mapper.tib_stacks.keys()),
            sorted(mapper.tib_stack_characters))
